Subject: [ppsp] initial proposal of PPSP component architecture

From: "zhangyunfei" <[email-masked]>
Date: Tue, 23 Jun 2009 18:01:20 +0800

Dear all,
    As Gonzalo suggested,PPSP problem statement draft is better to include a figure to express the component architecture.I propose the following layer architecture as the initial input.The components architecuture is as follows:
    
   +=================================================================+
   | +-------------------------------------------------------------+ |
   | |                       Application Layer                     | |
   | +-------------------------------------------------------------+ |
   |=================================================================|
   |  Play-out Layer                                                 |
   |  +----------------+    +---------------+    +-----------------+ |
   |  |     start      |    |      Pause    |    |       Stop      | |
   |  +----------------+    +---------------+    +-----------------+ |
   |=================================================================|
   |  Information Layer                                              |
   |  +----------------+    +---------------+    +-----------------+ |
   |  |  Registration  |    |     Report    |    |    Statistics   | |
   |  +----------------+    +---------------+    +-----------------+ |
   |=================================================================|
   |  Communication Layer                                            |
   | +------------------------+   +--------------------------------+ |
   | |    Topology Creation   |   |Head Node/Tracker Communication | |
   | +------------------------+   +--------------------------------+ |
   | +------------------------+   +--------------------------------+ |
   | | Neighbor Communication |   |          Bootstrap             | |
   | +------------------------+   +--------------------------------+ |
   |=================================================================|
   | +-------------------------------------------------------------+ |
   | |                       Transport Layer                       | |
   | +-------------------------------------------------------------+ |
   |=================================================================|

It can be divided into 5 layers:
1)Transport Layer is responsible for data transmission between peers, UDP,TCP or other protocols can be used;
2)Communicaton layer is the key layer in PPSP, including four components:
      1)Topology creation is a component each peer has to request to join the overlay,like tree or    mesh;
      2)Head Node/Tracker Communication is a component each peer continually to get peer list or peer info report to the tracker or head node.
      3)Neighbor Communication is a component that peers exchange bitmap or other neigbor availability information for loop avoidance(in tree).
      4)Bootstrap is a component to introduce a newly joined node to get the tracker or head node information.It keeps monitoring the trackers and head nodes.
3)Information layer is a layer that nodes register to the system,publish their contents,report their useful inforamation beyond those in the peer tracker reporting for peer selection and give statistics to the trackers.The tracker itself also use statistic and report module for global control in upload bandwidth consumption,overhead consumption and other regards.
4)Play-out layer is a layer to control the action of the media brower.RTSP is in this scope.
5)Application layer is the top layer in the ISO/OSI model,where PPSP application exists.

We are planning to add this part in the Problem statement draft.Any comments are welcome.

        BR

      yunfei
    2009-06-23

---

From: Alex Kyungho KIM <[email-masked]>
Date: Tue, 23 Jun 2009 22:58:25 +0900

Dear my colleagues,

Thank you your quick response on my question

So, I am not sure what you concern the role of 'Application Layer' is. we
agree on the core of PPSP would be the communication layer in the OSI 7
Layer apsect.

What would you expect any problems happening if 'Application layer' is not
face on 'Communication layer'?

Let's say 'Application Layer' is able to access the 'Play-out layer; and
'Information layer' but don't 'touch' the 'Communication layer'. We may
extend the role of 'Information layer' to cover some functionality of what
osh93 want. It could be 'session management' which is relavant to
'Communication layer'.

How do you think of this?

+=================================================================+
  | +-------------------------------------------------------------+ |
  | |                       Application Layer                     | |
  | |---------------------------------------------------------------+ |
  | +==================================================|
  | +-----------------------------+--------------------------------+
    |     Play-out Layer     |    Information Layer    |
  | +-----------------------------+--------------------------------+
  |=================================================================|
  |  Communication Layer                                            |
  | +------------------------+   +--------------------------------+ |
  | |    Topology Creation   |   |Head Node/Tracker Communication | |
  | +------------------------+   +--------------------------------+ |
  | +------------------------+   +--------------------------------+ |
  | | Neighbor Communication |   |          Bootstrap             | |
  | +------------------------+   +--------------------------------+ |
  |=================================================================|
  | +-------------------------------------------------------------+ |
  | |                       Transport Layer                       | |
  | +-------------------------------------------------------------+ |
  |=================================================================|

Regards,
Alex

2009/6/23 오승훈_2009 <[email-masked]>

>  Dear Alex
>
>
>
> Sorry for my ambiguous expression.
>
> That means that ‘Application Layer’ and ‘Communication Layer’ are adjacent.
>
>
> Is that clear now?
>
>
>
> Best Regards,
>
> Seung-Hun Oh
>
>
>
> *From:* [email-masked] [mailto:[email-masked]] *On Behalf Of *Alex
> Kyungho KIM
> *Sent:* Tuesday, June 23, 2009 10:17 PM
> *To:* [email-masked]
> *Subject:* Re: [ppsp] ***SPAM*** 7.949 (5) RE: initial proposal of PPSP
> component architecture
>
>
>
> Dear osh93,
>
>
>
> This is high level diagram to make someone understand our work or what we
> are doing. You have several modifications but I should ask you a
> question about your proposal.
>
>
>
> I am not clear "touch each other" in your comment. What does it mean?
>
>
>
> Regards,
>
> Alex
>
> 2009/6/23 오승훈_2009 <[email-masked]>
>
> Dear yunfei
>
> I think it is good idea to in insert this figure into the PPSP problem
> statement draft.
> But I think it needs more clarification.
>
> I think that the word, 'layer', is not appropriate for 'Play-out Layer' and
> 'Information Layer', or the position of them need to be a little bit
> modified.
> As you know, each layer must be vertically related in communication world,
> as far as I know.
> Here is my minor proposal:
>   | |          +--------------------------------------------------+ |
>   | |          | +==================================================|
>   | |          | |     Play-out Layer     |    Information Layer    |
>   | |          | |  +----+  +----+  +---+ |   +----+  +----+  +---+ |
>   | |          | |  |    |  |    |  |   | |   |    |  |    |  |   | |
>   | +----------+ |  +----+  +----+  +---+ |   +----+  +----+  +---+ |
> I try to locate both 'Play-out Layer' and 'Info. Layer' parallely and
> 'Application Layer' and 'Communication Layer' try to be located to touch
> each other.
>
> These are just my opinion.
>
> Best Regards,
>
> Seung-Hun Oh
>
>
> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]] On Behalf Of
> zhangyunfei
> Sent: Tuesday, June 23, 2009 7:01 PM
> To: [email-masked]
> Subject: [ppsp] initial proposal of PPSP component architecture
>
>
> Dear all,
>    As Gonzalo suggested,PPSP problem statement draft is better to include
> a figure to express the component architecture.I propose the following
> layer architecture as the initial input.The components architecuture is as
> follows:
>
>      2)Head Node/Tracker Communication is a component each peer
> continually to get peer list or peer info report to the tracker or head
> node.
>      3)Neighbor Communication is a component that peers exchange bitmap or
> other neigbor availability information for loop avoidance(in tree).
>      4)Bootstrap is a component to introduce a newly joined node to get
> the tracker or head node information.It keeps monitoring the trackers and
> head nodes.
> 3)Information layer is a layer that nodes register to the system,publish
> their contents,report their useful inforamation beyond those in the peer
> tracker reporting for peer selection and give statistics to the
> trackers.The tracker itself also use statistic and report module for global
> control in upload bandwidth consumption,overhead consumption and other
> regards.
> _______________________________________________
> ppsp mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ppsp
>
> _______________________________________________
> ppsp mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ppsp
>
>
>
>
> --
> Alex Kyungho KIM
> LG Electronics.
> Senior Research Engineer
> E-mail  : [email-masked]
> Office  : +82   2 2102 0111
> Mobile : +82 10 7917 0406
> FAX     : +82   2 2102 0140
> DTV Research Laboratory, LG Electronics.
> Seoul University Research Park
> San 4-1, BongCheon 7-Dong
> KwanAk-Gu,Seoul, 151-919
> The Republic of Korea.
>
> _______________________________________________
> ppsp mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ppsp
>
>

-- 
Alex Kyungho KIM
LG Electronics.
Senior Research Engineer
E-mail  : [email-masked]
Office  : +82   2 2102 0111
Mobile : +82 10 7917 0406
FAX     : +82   2 2102 0140
DTV Research Laboratory, LG Electronics.
Seoul University Research Park
San 4-1, BongCheon 7-Dong
KwanAk-Gu,Seoul, 151-919
The Republic of Korea.

---

From: "zhangyunfei" <[email-masked]>
Date: Thu, 25 Jun 2009 17:38:00 +0800

Sorry,Alex,
   The figure cannot display rightly in the email.Would you please send it again for clarification?Thanks in advance.

              Yunfei

zhangyunfei
2009-06-25

发件人： Alex Kyungho KIM
发送时间： 2009-06-23 21:58:34
收件人： [email-masked]; [email-masked]
抄送： 
主题： Re: [ppsp] ***SPAM*** 5.979 (5) RE: ***SPAM*** 7.949 (5) RE:initialproposal of PPSP component architecture

Dear my colleagues,
?
Thank you your?quick response on my question
?
So, I am not sure what you concern the role of 'Application Layer' is. we agree on the core of PPSP?would be the?communication layer in the OSI 7 Layer apsect. 
?
What would you expect?any problems happening if 'Application layer' is not face?on 'Communication layer'???
?
Let's say 'Application Layer'?is able to access?the 'Play-out layer; and 'Information layer' but don't 'touch' the 'Communication layer'. We may extend the role of 'Information layer' to cover some functionality of what osh93 want. It could be 'session management' which is relavant to 'Communication layer'.
?
How?do you think of this?
?
+=================================================================+
? | +-------------------------------------------------------------+ |
? | | ? ? ? ? ? ? ? ? ? ? ? Application Layer ? ? ? ? ? ? ? ? ? ? | |
? | |---------------------------------------------------------------+ |
? |?+==================================================|
? |?+-----------------------------+--------------------------------+
??? | ? ? Play-out Layer ? ? | ? ?Information Layer ? ?|
? |?+-----------------------------+--------------------------------+
? |=================================================================|
? | ?Communication Layer ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ?|
? | +------------------------+ ? +--------------------------------+ |
? | | ? ?Topology Creation ? | ? |Head Node/Tracker Communication | |
? | +------------------------+ ? +--------------------------------+ |
? | +------------------------+ ? +--------------------------------+ |
? | | Neighbor Communication | ? | ? ? ? ? ?Bootstrap ? ? ? ? ? ? | |
? | +------------------------+ ? +--------------------------------+ |
? |=================================================================|
? | +-------------------------------------------------------------+ |
? | | ? ? ? ? ? ? ? ? ? ? ? Transport Layer ? ? ? ? ? ? ? ? ? ? ? | |
? | +-------------------------------------------------------------+ |
? |=================================================================|

?
Regards,
Alex
?
2009/6/23 ???_2009 <[email-masked]>

Dear Alex
?
Sorry for my ambiguous expression. 
That means that ‘Application Layer’ and ‘Communication Layer’ are adjacent. 
Is that clear now?
?
Best Regards,
Seung-Hun Oh
?
From: [email-masked] [mailto:[email-masked]] On Behalf Of Alex Kyungho KIM
Sent: Tuesday, June 23, 2009 10:17 PM
To: [email-masked]
Subject: Re: [ppsp] ***SPAM*** 7.949 (5) RE: initial proposal of PPSP component architecture
?
Dear osh93,
?
This is high level diagram to make someone understand our work or what we are doing. You have several modifications but I should ask you a question?about your proposal.
?
I am not clear "touch each other" in your comment. What does it mean? 
?
Regards,
Alex
2009/6/23 ???_2009 <[email-masked]>
Dear yunfei

I think that the word, 'layer', is not appropriate for 'Play-out Layer' and
'Information Layer', or the position of them need to be a little bit
modified.
As you know, each layer must be vertically related in communication world,
as far as I know.
Here is my minor proposal:
? +=================================================================+
? | +-------------------------------------------------------------+ |
? | | ? ? ? ? ? ? ? ? ? ? ? Application Layer ? ? ? ? ? ? ? ? ? ? | |
? | | ? ? ? ? ?+--------------------------------------------------+ |
? | | ? ? ? ? ?| +==================================================|
? | | ? ? ? ? ?| | ? ? Play-out Layer ? ? | ? ?Information Layer ? ?|
? | | ? ? ? ? ?| | ?+----+ ?+----+ ?+---+ | ? +----+ ?+----+ ?+---+ |
? | | ? ? ? ? ?| | ?| ? ?| ?| ? ?| ?| ? | | ? | ? ?| ?| ? ?| ?| ? | |
? | +----------+ | ?+----+ ?+----+ ?+---+ | ? +----+ ?+----+ ?+---+ |
? |=================================================================|
? | ?Communication Layer ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ?|
? | +------------------------+ ? +--------------------------------+ |
? | | ? ?Topology Creation ? | ? |Head Node/Tracker Communication | |
? | +------------------------+ ? +--------------------------------+ |
? | +------------------------+ ? +--------------------------------+ |
? | | Neighbor Communication | ? | ? ? ? ? ?Bootstrap ? ? ? ? ? ? | |
? | +------------------------+ ? +--------------------------------+ |
? |=================================================================|
? | +-------------------------------------------------------------+ |
? | | ? ? ? ? ? ? ? ? ? ? ? Transport Layer ? ? ? ? ? ? ? ? ? ? ? | |
? | +-------------------------------------------------------------+ |
? |=================================================================|

Best Regards,

Seung-Hun Oh

-----Original Message-----

Dear all,
? ?As Gonzalo suggested,PPSP problem statement draft is better to include
a figure to express the component architecture.I propose the following
layer architecture as the initial input.The components architecuture is as
follows:

? +=================================================================+
? | +-------------------------------------------------------------+ |
? | | ? ? ? ? ? ? ? ? ? ? ? Application Layer ? ? ? ? ? ? ? ? ? ? | |
? | +-------------------------------------------------------------+ |
? |=================================================================|
? | ?Play-out Layer ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? |
? | ?+----------------+ ? ?+---------------+ ? ?+-----------------+ |
? | ?| ? ? start ? ? ?| ? ?| ? ? ?Pause ? ?| ? ?| ? ? ? Stop ? ? ?| |
? | ?+----------------+ ? ?+---------------+ ? ?+-----------------+ |
? |=================================================================|
? | ?Information Layer ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ?|
? | ?+----------------+ ? ?+---------------+ ? ?+-----------------+ |
? | ?| ?Registration ?| ? ?| ? ? Report ? ?| ? ?| ? ?Statistics ? | |
? | ?+----------------+ ? ?+---------------+ ? ?+-----------------+ |
? |=================================================================|
? | ?Communication Layer ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ?|
? | +------------------------+ ? +--------------------------------+ |
? | | ? ?Topology Creation ? | ? |Head Node/Tracker Communication | |
? | +------------------------+ ? +--------------------------------+ |
? | +------------------------+ ? +--------------------------------+ |
? | | Neighbor Communication | ? | ? ? ? ? ?Bootstrap ? ? ? ? ? ? | |
? | +------------------------+ ? +--------------------------------+ |
? |=================================================================|
? | +-------------------------------------------------------------+ |
? | | ? ? ? ? ? ? ? ? ? ? ? Transport Layer ? ? ? ? ? ? ? ? ? ? ? | |
? | +-------------------------------------------------------------+ |
? |=================================================================|

It can be divided into 5 layers:
1)Transport Layer is responsible for data transmission between peers,
UDP,TCP or other protocols can be used;
2)Communicaton layer is the key layer in PPSP, including four components:
? ? ?1)Topology creation is a component each peer has to request to join
the overlay,like tree or ? ?mesh;
? ? ?2)Head Node/Tracker Communication is a component each peer
continually to get peer list or peer info report to the tracker or head
node.
? ? ?3)Neighbor Communication is a component that peers exchange bitmap or
other neigbor availability information for loop avoidance(in tree).
? ? ?4)Bootstrap is a component to introduce a newly joined node to get
the tracker or head node information.It keeps monitoring the trackers and
head nodes.
3)Information layer is a layer that nodes register to the system,publish
their contents,report their useful inforamation beyond those in the peer
tracker reporting for peer selection and give statistics to the
trackers.The tracker itself also use statistic and report module for global
control in upload bandwidth consumption,overhead consumption and other
regards.
4)Play-out layer is a layer to control the action of the media brower.RTSP
is in this scope.
5)Application layer is the top layer in the ISO/OSI model,where PPSP
application exists.

We are planning to add this part in the Problem statement draft.Any
comments are welcome.

? ? ? ?BR

? ? ?yunfei
? ?2009-06-23

-- 
Alex Kyungho KIM
LG Electronics.
Senior Research Engineer
E-mail ?: [email-masked]
Office ?: +82 ? 2 2102 0111
Mobile : +82 10 7917 0406
FAX ? ? : +82 ? 2 2102 0140
DTV Research Laboratory, LG Electronics.
Seoul University Research Park
San 4-1, BongCheon 7-Dong 
KwanAk-Gu,Seoul, 151-919 
The Republic of Korea.

-- 
Alex Kyungho KIM
LG Electronics.
Senior Research Engineer
E-mail ?: [email-masked]
Office ?: +82 ? 2 2102 0111
Mobile : +82 10 7917 0406
FAX ? ? : +82 ? 2 2102 0140
DTV Research Laboratory, LG Electronics.
Seoul University Research Park
San 4-1, BongCheon 7-Dong 
KwanAk-Gu,Seoul, 151-919 
The Republic of Korea.

---

From: Alex Kyungho KIM <[email-masked]>
Date: Fri, 26 Jun 2009 20:43:08 +0900

Dear all,

There is a missing line.

+=================================================================+
| +-------------------------------------------------------------+ |
| |                       Application Layer                     | |
| |-------------------------------------------------------------+ |
+=================================================================+
| +-----------------------------+ +-----------------------------+ |
| | Play-out Layer              | | Information Layer           | |
| | +-------------------------+ | | +----+-------+------------+ | |
| | |Playback(Play,Pause,Stop)| | | |Auth|Session|Report/Stats| | |
| | +-------------------------+ | | +----+-------+------------+ | |
| +-----------------------------+ +-----------------------------+ |
|=================================================================|
|  Communication Layer                                            |
| +------------------------+   +--------------------------------+ |
| |    Topology Creation   |   |Head Node/Tracker Communication | |
| +------------------------+   +--------------------------------+ |
| +------------------------+   +--------------------------------+ |
| | Neighbor Communication |   |          Bootstrap             | |
| +------------------------+   +--------------------------------+ |
|=================================================================|
| +-------------------------------------------------------------+ |
| |                      Transport Layer                        | |
| +-------------------------------------------------------------+ |
|=================================================================|
| +-------------------------------------------------------------+ |
| |                      Physical Layer                         | |
| +-------------------------------------------------------------+ |
+=================================================================+

Regards,
Alex

On Fri, Jun 26, 2009 at 8:04 PM, Alex Kyungho KIM<[email-masked]> wrote:
> Dear Yunfei,
>
> I didn't know my drawing are disruptive. :)
>
> | |-------------------------------------------------------------+ |
> | +-----------------------------+ +-------------------------------+
> | | Play-out Layer              | | Information Layer             |
> | | +-------------------------+ | | +------+-------+------------+ |
> | | |Playback(Play,Pause,Stop)| | | | Auth |Session|Report/Stats| |
> | | +-------------------------+ | | +------+-------+------------+ |
> | +-----------------------------+ +-------------------------------+
> | |                      Physical Layer                         | |
> If you have same trouble, Please look into the enclosed TEXT file.
>
> My recommendation is to seperate the application layer and any lower
> layer. that is the best way to archive the flexiblity and more
> extendible.
>
> Regards,
> Alex
>
>
>
> 2009/6/25 zhangyunfei <[email-masked]>:
>> Sorry,Alex,
>>    The figure cannot display rightly in the email.Would you please send it
>> again for clarification?Thanks in advance.
>>
>>               Yunfei
>>
>> ________________________________
>> zhangyunfei
>> 2009-06-25
>> ________________________________
>> 发件人： Alex Kyungho KIM
>> 主题： Re: [ppsp] ***SPAM*** 5.979 (5) RE: ***SPAM*** 7.949 (5)
>> RE:initialproposal of PPSP component architecture
>>
>> Dear my colleagues,
>> ?
>> agree on the core of PPSP?would be the?communication layer in the OSI 7
>> Layer apsect.
>> ?
>> Let's say 'Application Layer'?is able to access?the 'Play-out layer; and
>>> question?about your proposal.
>>>
>>> ?
>>>

---

From: Alex Kyungho KIM <[email-masked]>
Date: Fri, 26 Jun 2009 20:04:49 +0900

Dear Yunfei,

Regards,
Alex

---

From: 오승훈_2009 <[email-masked]>
Date: Mon, 29 Jun 2009 15:55:24 +0900

Test

---

From: "zhangyunfei" <[email-masked]>
Date: Tue, 30 Jun 2009 18:00:51 +0800

I have the same question with Mr.Ｏｈ．In my point of view, authentication is a kind of action a telecom system must have.However in most of current p2p streaming systems,such an action is not the basic functionality they have while regirstation is an action the publishing node(server)must take.
Another question:What does the session module mean?I think most of the process related to "session"is included in the communication layer.

                         Yunfei

zhangyunfei
2009-06-30

发件人： 오승훈_2009
发送时间： 2009-06-29 15:02:14
收件人： 'Alex Kyungho KIM'; 'zhangyunfei'
抄送： [email-masked]
主题： RE: [ppsp] ***SPAM*** 5.979 (5) RE: ***SPAM*** 7.949 (5)RE:initialproposal of PPSP component architecture

Hello  Alex,  

Now  I  can  see  your  figure  properly.  Thanks  for  your  re-drawing.  
One  question  about  figure  below:
The  components  in  "Information  Layer"  are  a  little  different  from  the  original  one.
Registration  is  changed  into  'Auth'.  Is  there  any  reason?  

Regards,
Seung-Hun  Oh

-----Original  Message-----
From:  [email-masked]  [mailto:[email-masked]]  On  Behalf  Of  Alex  Kyungho  KIM
Sent:  Friday,  June  26,  2009  8:43  PM
To:  zhangyunfei
Cc:  [email-masked];  [email-masked]
Subject:  Re:  [ppsp]  ***SPAM***  5.979  (5)  RE:  ***SPAM***  7.949  (5)  RE:initialproposal  of  PPSP  component  architecture

Dear  all,

There  is  a  missing  line.

Regards,
Alex

On  Fri,  Jun  26,  2009  at  8:04  PM,  Alex  Kyungho  KIM <[email-masked] >  wrote:
>  2009/6/25  zhangyunfei   <[email-masked] >:
> >  Sorry,Alex,
> >  2009/6/23  ???_2009   <[email-masked] >
> > >
> > >  Dear  Alex
> > >
> > >  ?
> > >
> > >  2009/6/23  ???_2009   <[email-masked] >
> > >
> > >  Dear  yunfei
> > >